#!/usr/bin/perl
# -*- mode: perl; perl-indent-level: 2 -*-

# Author: Mark-Jason Dominus (mjd@pobox.com) September 1997
# It is in the public domain.

require 'bool.pl';
#$yylexdebug = 1;    # Uncomment this to durn on debugging in the lexer.
#$yydebug = 1;       # Uncomment this to durn on debugging in the parser.

# Values of atoms
%atom_table = 
    (a => 1,
     b => 0,
     c => 1,);

#
# Main program
#
while (<>) {
  chomp;
  $new_input = $_;
  if (yyparse()==0) {  # Parse `$new_input' and leave result in $values[0].
    my $valstr = $values[0] ? TRUE : FALSE;
    print "$_\n\t==> $valstr\n";
  } else {
    print "$_:\n\t==> Syntax error.\n";
  }
}

#
# Lexer
#
{ my @tokens;
sub yylex {
  my $MODE;

  if (@tokens == 0  && $new_input) {
    @tokens = $new_input =~ /([\w.]+|\d+|\s+|[^\w.\d\s])/g;
    undef $new_input;
  }

  my $next_token = shift @tokens;

  if ($next_token eq '') {
    return End_of_Input;
  } elsif ($next_token =~ /\d/) {
    $yylval = $next_token;
    return NUMBER;
  } elsif  ($next_token =~ /[\w.]/) {
    $yylval = $next_token;
    return STRING;
  } else {
    return $next_token;
  }
}
}
